/**
 * 所有API
 */
;!(function () {
    var api = BI.inherit(BI.Widget, {

        props: {},

        _store: function () {
            return BI.Models.getModel("dec.model.api.all");
        },
        watch: {
            "selectedGroup.id": function () {
                this.table.reload();
            }
        },

        render: function () {
            var self = this, o = this.options;

            return {
                type: "bi.htape",
                items: [
                    {
                        type: "dec.client.api.group",
                        cls: "bi-border-right",
                        width: 300,
                    }, {
                        el: {
                            type: "bi.absolute",
                            items: [
                                {
                                    el: {
                                        type: "dec.client.widget.table",
                                        ref: function (_ref) {
                                            self.table = _ref;
                                        },
                                        showTrans: true,//显示转换分组
                                        //  limited: true,
                                        perPage: 1000,//这个没有分组分页api，直接一页显示吧
                                        cardType: "dec.api.info",
                                        cardHeight: 600,
                                        header: [{text: BI.i18nText("Plugin-Dec-Management_Client_Table_Header_Name")}, {text: BI.i18nText("Plugin-Dec-Management_Client_Table_Header_Description")}, {text: BI.i18nText("Plugin-Dec-Management_Client_API_isPublic")}, {text: "API" + BI.i18nText("Plugin-Dec-Management_Client_API_Path")}, {text: "API" + BI.i18nText("Plugin-Dec-Management_Client_API_Method")}, {text: BI.i18nText("Plugin-Dec-Management_Client_Table_Header_Enable")}, {text: ""}],
                                        columnSize: [2 / 14, 3 / 14, 2 / 14, 2 / 14, 2 / 14, 2 / 14, 1 / 14],
                                        showTools: true,
                                        itemsCreateFn: function (page, perCount, keyWord) {
                                            var items = Dec.Utils.Client.Relation.get(self.model.selectedGroup.id);
                                            return {
                                                success: true,
                                                data: {total: items.length, items: items}
                                            };
                                        },
                                        addItemFn: function (val) {

                                            var data = Dec.Utils.Client.API.add(val);
                                            if (data.errorCode) {
                                                return {success: false, errorMsg: DecCst.client.formatMsg(data)}
                                            }
                                            if (self.model.selectedGroup.id != DecCst.client.nogroup.id) {//选择了具体的分组就添加进去
                                                Dec.Utils.Client.Relation.set([{
                                                    apiId: data.id,
                                                    groupId: self.model.selectedGroup.id
                                                }], []);
                                            }
                                            return {success: true, data: data};
                                        },
                                        deleteItemFn: function (deleteIds) {
                                            if (self.model.selectedGroup.id != DecCst.client.nogroup.id) {
                                                Dec.Utils.Client.Relation.set([], BI.map(deleteIds, function (index, item) {//先从分组里面删除了
                                                    return {
                                                        apiId: item,
                                                        groupId: self.model.selectedGroup.id
                                                    }
                                                }));
                                            }

                                            var data = Dec.Utils.Client.API.remove(deleteIds);//再删除这个

                                            if (data === "success") {
                                                return {success: true, data: data}
                                            }
                                            return {success: false, errorMsg: DecCst.client.formatMsg(data)}
                                        },
                                        updateItemFn: function (item) {
                                            var result = {success: true};
                                            var data = Dec.Utils.Client.API.update(item);
                                            if (data.errorCode) {
                                                return {success: false, errorMsg: DecCst.client.formatMsg(data)}
                                            } else {
                                                result.data = data;
                                            }
                                            return result;
                                        },
                                        transferAPIFn: function (apiIds, groupId) {
                                            Dec.Utils.Client.Relation.set(groupId != DecCst.client.nogroup.id ? BI.map(apiIds, function (index, item) {//不是添加到默认分组的哈 就需要增加一次
                                                return {
                                                    apiId: item,
                                                    groupId: groupId
                                                }
                                            }) : [], self.model.selectedGroup.id != DecCst.client.nogroup.id ? BI.map(apiIds, function (index, item) {//先从分组里面删除了
                                                return {
                                                    apiId: item,
                                                    groupId: self.model.selectedGroup.id
                                                }
                                            }) : []);
                                            return {success: true};

                                        },
                                        customFormat: function (items) {
                                            return BI.map(items, function (index, item) {
                                                return {
                                                    id: item.id,
                                                    name: item.name,
                                                    description: item.description,
                                                    //   clazz: item.clazz,
                                                    isPublic: item.isPublic ? BI.i18nText("Plugin-Dec-Yes") : BI.i18nText("Plugin-Dec-Yes"),
                                                    info: item.info,
                                                    method: item.method,
                                                    editable: item.editable != 0,
                                                    enable: (BI.Constants.getConstant("dec.constant.client.disable.config"))[item.enable]
                                                    // config: item.config,
                                                    //dftParams: item.dftParams
                                                }
                                            })
                                        }
                                    },
                                    top: 0, left: 0, bottom: 0, right: 0
                                }
                            ]
                        }
                    }
                ]
            };
        },
    });
    BI.shortcut("dec.api.all", api);
}());
;!(function () {
    var Model = BI.inherit(Fix.Model, {
        _init: function () {

        },

        state: function () {
            return {
                selectedGroup: BI.deepClone(DecCst.client.nogroup)
            };
        },

        childContext: ["selectedGroup"],

        computed: {},

        watch: {},

        actions: {},
    });
    BI.model("dec.model.api.all", Model);
}());

