;!(function () {
    var widget = BI.inherit(BI.Widget, {
        props: {},
        render: function () {
            var self = this, o = this.options;
            return {
                type: "bi.absolute",
                items: [
                    {
                        el: {
                            type: "dec.client.widget.table",
                            cardType: "dec.auth.info",
                            cardHeight: 600,
                            header: [{text: BI.i18nText("Plugin-Dec-Management_Client_Table_Header_Name")}, {text: BI.i18nText("Plugin-Dec-Management_Client_Table_Header_Description")}, {text: BI.i18nText("Plugin-Dec-Management_Client_Table_Header_Enable")}, {text: ""}],
                            columnSize: [2 / 8, 3 / 8, 2 / 8, 1 / 8],
                            showTools: true,
                            itemsCreateFn: function (page, perCount, keyWord) {
                                return {success: true, data: Dec.Utils.Client.Auth.page(page, perCount, keyWord)};
                            },
                            addItemFn: function (val) {
                                var result = {success: true};
                                var data = Dec.Utils.Client.Auth.add(val);
                                if (data.errorCode) {
                                    return {success: false, errorMsg: DecCst.client.formatMsg(data)}
                                } else {
                                    result.data = data;
                                }
                                return result;
                            },
                            deleteItemFn: function (deleteIds) {
                                var result = {success: true};
                                var data = Dec.Utils.Client.Auth.remove(deleteIds);
                                if (data.errorCode) {
                                    return {success: false, errorMsg: DecCst.client.formatMsg(data)}
                                } else {
                                    result.data = data;
                                }
                                return result;
                            },
                            updateItemFn: function (item) {
                                var result = {success: true};
                                var data = Dec.Utils.Client.Auth.update(item);
                                if (data.errorCode) {
                                    return {success: false, errorMsg: DecCst.client.formatMsg(data)}
                                } else {
                                    result.data = data;
                                }
                                return result;
                            },
                            customFormat: function (items) {
                                return BI.map(items, function (index, item) {
                                    return {
                                        id: item.id,
                                        name: item.name,
                                        description: item.description,
                                        editable: item.editable != 0,
                                        // clazz: item.clazz,
                                        //  config: item.config,
                                        // dftParams: item.dftParams,
                                        enable: (BI.Constants.getConstant("dec.constant.client.disable.config"))[item.enable]
                                    }
                                })
                            }
                        },
                        top: 0, left: 0, bottom: 0, right: 0
                    }
                ]
            }
        }

    });
    BI.shortcut("dec.type.authentication", widget);
})();