!(function () {
    var EDITOR_WIDTH = 300, EDITOR_HEIGHT = 22, LABEL_WIDTH = 100;


    var authInfo = BI.inherit(BI.Widget, {

        props: {
            info: {}
        },
        _store: function () {
            return BI.Models.getModel("dec.auth.info.model");
        },
        beforeInit: function (callback) {
            // 当请求结束后进行callback回调
            this.store.reqClazz(callback);
        },
        render: function () {
            var self = this, o = this.options, borderEditorWidth = EDITOR_WIDTH - 2;
            var editable = o.info.editable != 0;//不等于0就是可以编辑的

            return {
                type: "bi.vertical",
                //  width: 540,
                vgap: 15,
                scrolly: true,
                items: [{
                    type: "bi.vertical_adapt",
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_Auth_Name")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "bi.text_editor",
                            disabled: !editable,
                            value: o.info.name,
                            watermark: BI.i18nText("Plugin-Dec-Empty-Not-Allow"),
                            allowBlank: false,
                            textAlign: "left",
                            width: borderEditorWidth,
                            height: EDITOR_HEIGHT,
                            ref: function (_ref) {
                                self.nameCol = _ref;
                            }
                        },
                        lgap: 10
                    }]
                }, {
                    type: "bi.vertical_adapt",

                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_Auth_Description")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "bi.textarea_editor",
                            disabled: !editable,
                            cls: "bi-border",
                            value: o.info.description,
                            allowBlank: true,
                            textAlign: "left",
                            width: borderEditorWidth,
                            height: 100,
                            ref: function (_ref) {
                                self.descriptionCol = _ref;
                            }
                        },
                        lgap: 10
                    }]
                }, {
                    type: "bi.vertical_adapt",
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_Clazz")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "bi.text_value_combo",
                            //type: "bi.text_editor",
                            items: self.model.clazzes,
                            disabled: !editable,
                            value: o.info.clazz,
                            allowBlank: true,
                            textAlign: "left",
                            width: borderEditorWidth,
                            height: EDITOR_HEIGHT,
                            ref: function (_ref) {
                                self.clazzCol = _ref;
                            }
                        },
                        lgap: 10
                    }]
                }, {
                    type: "bi.vertical_adapt",
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_Config")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "dec.client.widget.config.parameter.list",
                            items: self._createWidgetValue(o.info.config),
                            disabled: !editable,
                            textAlign: "left",
                            width: borderEditorWidth,
                            // height: EDITOR_HEIGHT,
                            ref: function (_ref) {
                                self.configCol = _ref;
                            }
                        },
                        lgap: 10
                    }]
                },
                    {
                        type: "bi.vertical_adapt",
                        items: [{
                            type: "bi.label",
                            textAlign: "left",
                            cls: "dec-font-weight-bold",
                            text: BI.i18nText("Plugin-Dec-Management_Client_Default_Para")+":",
                            width: LABEL_WIDTH
                        }, {
                            el: {
                                // type: "bi.multi_select_combo",
                                type: "dec.client.widget.config.parameter.list",
                                items: self._createWidgetValue(o.info.dftParams),
                                disabled: !editable,
                                textAlign: "left",
                                width: borderEditorWidth,
                                // height: EDITOR_HEIGHT,
                                ref: function (_ref) {
                                    self.dftParamsCol = _ref;
                                }
                            },
                            lgap: 10
                        }]
                    }]

            }
        },
        isEditable: function () {
            return this.options.info.editable != 0;
        },

        getValue: function () {
            var info = this.options.info;
            var self = this;
            return {
                id: info.id,
                name: self.nameCol.getValue(),
                description: self.descriptionCol.getValue(),
                clazz: self.clazzCol.getValue()[0],
                config: self._createUpValue(self.configCol.getValue()),
                dftParams: self._createUpValue(self.dftParamsCol.getValue())
            }
        },
        _createUpValue: function (vals) {//组件getValue是[{name:"a",value:"xx"}]的数组 需要转下
            var result = {};
            BI.each(vals, function (index, item) {
                result[item.name] = item.value;
            });
            return BI.jsonEncode(result);
        },
        _createWidgetValue: function (str) {
            if (BI.isNull(str) || BI.isEmptyString(str)) {
                return [];
            }
            var object = BI.jsonDecode(str);
            return BI.map(object, function (key, value) {
                return {
                    name: key,
                    value: value
                }
            });
        },
        checkValue: function () {
            var result = {status: true};
            if (BI.isEmptyString(this.nameCol.getValue())) {
                result.status = false;
                result.errorMsg = BI.i18nText("Plugin-Dec-Management_Client_Name_Not_Empty");
            }

            return result;
        },

        setValue: function (info) {

        }
    });
    BI.shortcut("dec.auth.info", authInfo);
}());