/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2020-07-28
 **/
!(function () {
    var ClientManage = BI.inherit(BI.Widget, {
        props: {
            baseCls: "dec-client-management"
        },

        _store: function () {
            return BI.Models.getModel("dec.model.client");
        },

        watch: {
            activeTab: function (v) {
                this.tab.setSelect(v);
            }
        },

        beforeInit: function (callback) {
            callback();
        },

        render: function () {
            var self = this;
            var nav = {
                type: "dec.line_segment",
                cls: "dec-font-weight-bold",
                ref: function (_ref) {
                    self.tabs = _ref;
                },
                height: 40,
                items: BI.createItems(this.model.tabs, {
                    hgap: 15
                }),
                layouts: [
                    {
                        type: "bi.vertical_adapt"
                    }
                ],
                listeners: [
                    {
                        eventName: "EVENT_CHANGE",
                        action: function (value) {
                            self.store.openTab(value);
                        }
                    }
                ]
            };
            return {
                type: "bi.absolute",
                cls: "bi-background",
                items: [
                    {
                        el: {
                            type: "bi.vtape",
                            items: [
                                {
                                    type: "bi.vertical_adapt",
                                    cls: "bi-card bi-border-bottom",
                                    items: [
                                        nav
                                    ],
                                    height: 40
                                }, {
                                    type: "bi.absolute",
                                    items: [
                                        {
                                            el: {
                                                type: "bi.tab",
                                                cardCreator: BI.bind(this.store.createCard, this),
                                                single: true,
                                                ref: function (_ref) {
                                                    self.tab = _ref;
                                                },
                                                showIndex: this.model.activeTab
                                            },
                                            top: 10, left: 10, right: 10, bottom: 10
                                        }
                                    ]
                                }
                            ]
                        },
                        left: 0, right: 0, top: 0, bottom: 0
                    }
                ]
            };
        }
    });
    BI.shortcut("dec.client.manage", ClientManage);
})();