/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2020-07-30
 **/
!(function () {
    Dec.Utils = Dec.Utils || {};
    var root = "/sp/client/api/";
    var proxyGet = function (path, query) {
        var result = {};
        Dec.syncAjax({
            url: root + path + "?" + query,
            type: "GET",
            success: function (res) {
                result = res;
            }
        });
        return result;
    };
    var proxyPost = function (path, data) {
        var result = {};
        Dec.syncAjax({
            url: root + path,
            type: "POST",
            data: data,
            success: function (res) {
                result = res;
            }
        });
        return result;
    };
    var proxyPut = function (path, data) {
        var result = {};
        Dec.syncAjax({
            url: root + path,
            type: "PUT",
            data: data,
            success: function (res) {
                result = res;
            }
        });
        return result;
    };
    var proxyDelete = function (path, data) {
        var result = {};
        Dec.syncAjax({
            url: root + path,
            type: "DELETE",
            data: data,
            success: function (res) {
                result = res;
            }
        });
        return result;
    };

    var uuid = function () {
        var part = function () {
            return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
        }
        return (part() + part() + part() + part() + part() + part() + part() + part());
    }
    //客户端会用到的各种方法，都封装在这里了
    var client = {
        path: "client",
        add: function (item) {
            /*
            * item 的结构{
                icon:icon,
                spareAuth:authType,
                name:name,
                description:description
            }
            * */
            var result = proxyPost(this.path, item);//需要抛错这边返回就要改下
            return result.data ? result.data : result;
        },
        update: function (item) {
            /*
            item 的结构{
                id:id,
                resetPass:resetPass,
                icon:icon,
                spareAuth:authType,
                name:name,
                description:description,
                enable:enable
            }
             */
            var result = proxyPut(this.path, item);//需要抛错这边返回就要改下
            return result.data ? result.data : result;
            //  return proxyPut(this.path, item).data;
        },
        remove: function (ids) {
            var result = proxyDelete(this.path, ids);
            return result.data ? result.data : result;
        },
        page: function (page, size, key) {
            var result = proxyGet(this.path, "page=" + page + "&size=" + size + "&key=" + key);
            return result.data ? result.data : result;
        }
    };
    var auth = {
        path: "auth",
        add: function (item) {
            /*
            item 的结构{
                clazz:clazz,
                config:config,
                dftParams:dftParams,
                name:name,
                description:description
            }
             */
            var result = proxyPost(this.path, item);
            return result.data ? result.data : result;
        },
        update: function (item) {
            /*
            item 的结构{
                id:id,
                clazz:clazz,
                config:config,
                dftParams:dftParams,
                name:name,
                description:description,
                enable:enable
            }
             */
            var result = proxyPut(this.path, item);
            return result.data ? result.data : result;
        },
        remove: function (ids) {
            var result = proxyDelete(this.path, ids);
            return result.data ? result.data : result;
        },
        page: function (page, size, key) {
            var result = proxyGet(this.path, "page=" + page + "&size=" + size + "&key=" + key);

            return result.data ? result.data : result;
        }
    };
    var api = {
        path: "api",
        add: function (item) {
            /**
             item 的结构{
                clazz:clazz,
                config:config,
                dftParams:dftParams,
                name:name,
                description:description,
                isPublic:isPublic,
                info:info,
                method:method
            }
             */
            var result = proxyPost(this.path, item);
            return result.data ? result.data : result;
        },
        update: function (item) {
            /**
             {
                id:id,
                clazz:clazz,
                config:config,
                dftParams:dftParams,
                name:name,
                description:description,
                enable:enable,
                isPublic:isPublic,
                info:info,
                method:method
            }
             */
            var result = proxyPut(this.path, item);
            return result.data ? result.data : result;
        },
        remove: function (ids) {
            var result = proxyDelete(this.path, ids);
            return result.data ? result.data : result;
        },
        page: function (page, size, key) {
            var result = proxyGet(this.path, "page=" + page + "&size=" + size + "&key=" + key);
            return result.data ? result.data : result;
        }
    };
    var group = {
        path: "group",
        add: function (item) {
            /**
             {
                name:name,
                description:description
            }
             */
            var result = proxyPost(this.path, item);
            return result.data ? result.data : result;
        },
        update: function (item) {
            /**
             {
                id:id,
                name:name,
                description:description,
                enable:enable
            }
             */
            var result = proxyPut(this.path, item);
            return result.data ? result.data : result;
        },
        remove: function (ids) {
            var result = proxyDelete(this.path, ids);
            return result.data ? result.data : result;
        },
        page: function (page, size, key) {
            var result = proxyGet(this.path, "page=" + page + "&size=" + size + "&key=" + key);
            return result.data ? result.data : result;
        }
    };
    var relation = {
        path: "relation",
        get: function (groupId) {
            var result = proxyGet(this.path, "groupId=" + groupId);
            return result.data ? result.data : result;
        },
        set: function (addList, removeList) {
            var result = proxyPost(this.path, {
                addList: addList,
                removeList: removeList
            });
            return result.data ? result.data : result;
        }
    };
    var privilege = {
        path: "privilege",
        get: function (type, id) {
            var result = proxyGet(this.path, "type=" + type + "&id=" + id);
            return result.data ? result.data : result;
        },
        set: function (addList, removeList) {
            var result = proxyPost(this.path, {
                addList: addList,
                removeList: removeList
            });
            return result.data ? result.data : result;
        }
    };
    var watcherList = {
        path:"watcher/list",
        get:function (page, pageSize) {
            var result = proxyGet(this.path,"page=" + page + "&pageSize=" + pageSize);
            return result.data ? result.data : result;
        }
    };
    var apiTree = {
        path:"api/tree",
        get:function () {
            var result = proxyGet(this.path);
            return result.data ? result.data : result;
        }
    };
    var authTree = {
        path:"auth/tree",
        get:function () {
            var result = proxyGet(this.path);
            return result.data ? result.data : result;
        }
    };
    var countChart = {
        path:"count/chart",
        get:function () {
            var result = proxyGet(this.path);
            return result.data ? result.data : result;
        }
    }
    var req = {
        Client: client,
        Auth: auth,
        API: api,
        Group: group,
        Relation: relation,
        Privilege: privilege,
        WatcherList:watcherList,
        ApiTree:apiTree,
        AuthTree:authTree,
        CountChart:countChart
    };
    BI.extend(Dec.Utils, {
        Client: req
    });
})();