;!(function () {
    var widget = BI.inherit(BI.Widget, {
        props: {},
        render: function () {
            var self = this, o = this.options;
            var authItems = self._createAuthItems();
            return {
                type: "bi.absolute",
                items: [
                    {
                        el: {
                            type: "dec.client.widget.table",
                            ref:function(_ref){
                                self.table=_ref;
                            },
                            cardType: "dec.client.info",
                            header: [{text: BI.i18nText("Plugin-Dec-Management_Client_Table_Header_Name")}, {text: BI.i18nText("Plugin-Dec-Management_Client_Table_Header_Description")}, {text: BI.i18nText("Plugin-Dec-Management_Client_Table_Header_auth")}, {text: BI.i18nText("Plugin-Dec-Management_Client_Table_Header_Enable")}, {text: ""}],
                            columnSize: [2 / 10, 3 / 10, 2 / 10, 2 / 10, 1 / 10],
                            showTools: true,
                            itemsCreateFn: function (page, perCount, keyWord) {
                                return {success: true, data: Dec.Utils.Client.Client.page(page, perCount, keyWord)};
                            },
                            addItemFn: function (val) {
                                var data = Dec.Utils.Client.Client.add(val);
                                if (data.errorCode) {
                                    return {success: false, errorMsg: DecCst.client.formatMsg(data)}
                                }
                                return {success: true, data: data};
                            },
                            deleteItemFn: function (deleteIds) {
                                var data = Dec.Utils.Client.Client.remove(deleteIds);
                                if (data === "success") {
                                    return {success: true, data: data}
                                }
                                return {
                                    success: false,
                                    errorMsg: DecCst.client.formatMsg(data)
                                }
                            },
                            updateItemFn: function (item) {
                                var result = {success: true};
                                var data = Dec.Utils.Client.Client.update(item);
                                if (data.errorCode) {
                                    return {success: false, errorMsg: DecCst.client.formatMsg(data)}
                                } else {
                                    result.data = data;
                                }
                                return result;
                            },
                            customFormat: function (items) {
                                return BI.map(items, function (index, item) {
                                    return {
                                        id: item.id,
                                        name: item.name,
                                        description: item.description,
                                        //  secret: item.secret,
                                        //createTime: item.createTime,
                                        spareAuth: authItems[item.spareAuth],
                                        enable: (BI.Constants.getConstant("dec.constant.client.disable.config"))[item.enable]
                                    }
                                })
                            }
                        },
                        top: 0, left: 0, bottom: 0, right: 0
                    }
                ]
            }
        },
        _createAuthItems: function () {
            var result = {};
            BI.each(Dec.Utils.Client.Auth.page(-1, 10, ""), function (index, item) {
                result[item.id] = item.name;
            })
            return result;
        },
        mounted: function () {
            var self = this;
            self.table.element
        }

    });
    BI.shortcut("dec.client.all", widget);
})();