!(function () {
    var EDITOR_WIDTH = 300, EDITOR_HEIGHT = 22, LABEL_WIDTH = 100;


    var clienInfo = BI.inherit(BI.Widget, {

        props: {
            info: {}
        },


        render: function () {
            var self = this, o = this.options, borderEditorWidth = EDITOR_WIDTH - 2;
            return {
                type: "bi.vertical",
                //  width: 540,
                vgap: 15,
                scrolly: true,
                items: [{
                    type: "bi.vertical_adapt",
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_Client_ID")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "bi.text_editor",
                            disabled: true,
                            value: o.info.id,
                          //  value: o.info.secret,
                            width: borderEditorWidth,
                            ref: function (_ref) {
                                self.spareAuthCol = _ref;
                            }
                        },
                        lgap: 10
                    }]
                },{
                    type: "bi.vertical_adapt",
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_Client_Name")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "bi.text_editor",
                            value: o.info.name,
                            watermark: "这个不允许为空",
                            allowBlank: false,
                            textAlign: "left",
                            width: borderEditorWidth,
                            height: EDITOR_HEIGHT,
                            ref: function (_ref) {
                                self.nameCol = _ref;
                            }
                        },
                        lgap: 10
                    }]
                }, {
                    type: "bi.vertical_adapt",

                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_Client_Description")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "bi.textarea_editor",
                            cls: "bi-border",
                            value: o.info.description,
                            allowBlank: true,
                            textAlign: "left",
                            width: borderEditorWidth,
                            height: 100,
                            ref: function (_ref) {
                                self.descriptionCol = _ref;
                            }
                        },
                        lgap: 10
                    }]
                }, {
                    type: "bi.vertical_adapt",
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_Client_Key")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "bi.text_editor",
                            disabled: true,
                            //value: o.info.id,
                            value: o.info.secret,
                            width: borderEditorWidth,
                            ref: function (_ref) {
                                self.spareAuthCol = _ref;
                            }
                        },
                        lgap: 10
                    }]
                }, {
                    type: "bi.vertical_adapt",
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_Table_Header_auth")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "bi.text_value_combo",
                            //value: o.info.id,
                            items: self._createAuthItems(),
                            value: o.info.spareAuth,
                            width: borderEditorWidth,
                            ref: function (_ref) {
                                self.spareAuthCol = _ref;
                            }
                        },
                        lgap: 10
                    }]
                }, {
                    type: "bi.vertical_adapt",
                    invisible: !BI.isKey(o.info.id),
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_Client_Reset_Password")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "bi.switch",
                            ref: function (_ref) {
                                self.resetPassCol = _ref;
                            },
                        },
                        lgap: 10
                    }]
                }]

            }
        },

        getValue: function () {
            var info = this.options.info;
            var self = this;
            return {
                id: info.id,
                name: self.nameCol.getValue(),
                description: self.descriptionCol.getValue(),
                spareAuth: (self.spareAuthCol.getValue())[0],
                resetPass: self.resetPassCol.isSelected()
            }
        },
        checkValue: function () {
            var result = {status: true};
            if (BI.isEmptyString(this.nameCol.getValue())) {
                result.status = false;
                result.errorMsg = BI.i18nText("Plugin-Dec-Management_Client_Name_Not_Empty");
            }

            return result;
        },
        _createAuthItems: function () {
            return BI.map(Dec.Utils.Client.Auth.page(-1, 10, ""), function (index, item) {
                return {
                    value: item.id,
                    text: item.name
                }
            })
        },

        setValue: function (info) {

        }
    });
    BI.shortcut("dec.client.info", clienInfo);
}());