!(function () {
    var EDITOR_WIDTH = 300, EDITOR_HEIGHT = 22, LABEL_WIDTH = 100;


    var groupInfo = BI.inherit(BI.Widget, {

        props: {
            info: {}
        },


        render: function () {
            var self = this, o = this.options, borderEditorWidth = EDITOR_WIDTH - 2;
            return {
                type: "bi.vertical",
                //  width: 540,
                vgap: 15,
                scrolly: true,
                items: [{
                    type: "bi.vertical_adapt",
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_API_group_Name")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "bi.text_editor",
                            value: o.info.name,
                            watermark: BI.i18nText("Plugin-Dec-Empty-Not-Allow"),
                            allowBlank: false,
                            textAlign: "left",
                            width: borderEditorWidth,
                            height: EDITOR_HEIGHT,
                            ref: function (_ref) {
                                self.nameCol = _ref;
                            }
                        },
                        lgap: 10
                    }]
                }, {
                    type: "bi.vertical_adapt",

                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Management_Client_API_group_Description")+":",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            // type: "bi.multi_select_combo",
                            type: "bi.textarea_editor",
                            cls: "bi-border",
                            value: o.info.description,
                            allowBlank: true,
                            textAlign: "left",
                            width: borderEditorWidth,
                            height: 100,
                            ref: function (_ref) {
                                self.descriptionCol = _ref;
                            }
                        },
                        lgap: 10
                    }]
                }]

            }
        },

        getValue: function () {
            var info = this.options.info;
            var self = this;
            return {
                id: info.id,
                name: self.nameCol.getValue(),
                description: self.descriptionCol.getValue(),
            }
        },
        checkValue: function () {
            var result = {status: true};
            if (BI.isEmptyString(this.nameCol.getValue())) {
                result.status = false;
                result.errorMsg = BI.i18nText("Plugin-Dec-Management_Client_Name_Not_Empty");
            }

            return result;
        },

        setValue: function (info) {

        }
    });
    BI.shortcut("dec.client.api.group.info", groupInfo);
}());