;!(function () {
    var groupItem = BI.inherit(BI.BasicButton, {

        props: {
            baseCls: "decision-client-api-group-item bi-list-item-active2",
            height: 24,
            description: "",
            onDelete: BI.emptyFn,
            bubbleText: "",
            showTools: true
        },

        render: function () {
            var self = this, o = this.options;
            var text = {
                type: "bi.label",
                textAlign: "left",
                height: o.height,
                text: o.name,
                hgap: 10,
                keyword: o.keyword,
                title: o.description
            };

            var editIcon = {
                type: "bi.icon_button",
                ref: function (_ref) {
                    self.editIcon = _ref;
                },
                cls: "edit-role-font",
                title: BI.i18nText("Dec-Basic_Edit"),
                stopPropagation: true,
                handler: function () {
                    o.onEdit(self.getItemValue());
                }
            };

            var deleteCombo = {
                type: "dec.bubble.combo",
                el: {
                    type: "bi.icon_button",
                    title: BI.i18nText("Dec-Basic_Delete"),
                },
                ref: function (_ref) {
                    self.deleteCombo = _ref;
                },
                cls: "delete-node-font",
                stopPropagation: true,
                offsetStyle: "center",
                text: BI.i18nText("Plugin-Dec-Management_Client_API_group_Delete_confirm")+"?",
                onClickConfirm: function () {
                    o.onDelete(o.id);
                },
            };


            var toolItems = [
                editIcon,
                deleteCombo,
            ];

            return {
                type: "bi.htape",
                items: [
                    {
                        el: text,
                    }, {
                        type: "bi.right_vertical_adapt",
                        cls: "group-item-tool",
                        hgap: 10,
                        items: o.editable != 0 ? toolItems : [],
                        width: 60
                    }
                ]
            };
        },

        getValue: function () {
            return this.options.id;
        },
        getItemValue: function () {
            return {
                id: this.options.id,
                name: this.options.name,
                description: this.options.description
            }
        }
    });

    BI.shortcut("dec.client.api.group.item", groupItem);
}());
