;!(function () {
    var EDIT = "edit", ADD = "add";
    var apiGroup = BI.inherit(BI.Widget, {
        props: {
            cardType: "dec.client.api.group.info"
        },
        beforeInit: function (callback) {
            this.store.initData(callback);
        },
        _store: function () {
            return BI.Models.getModel("dec.model.client.api.group");
        },
        watch: {
            popFlag: function () {
                this.populate(this.model.groupItems);
            }
        },
        render: function () {
            var self = this, o = this.options;

            var header = {
                type: "bi.htape",
                cls: "bi-border-bottom",
                height: 40,
                items: [
                    {
                        type: "bi.label",
                        textAlign: "left",
                        height: 40,
                        text: BI.i18nText("Plugin-Dec-Management_Client_API_group_List")+":",
                    }, {
                        type: "bi.icon_button",
                        cls: "text-add-tip-font",
                        width: 24,
                        handler: function () {
                            self._addOrEditPop(ADD, function (val, callback) {
                                self.store.addGroup(val, callback);
                            }, {})
                        }
                    }
                ]
            };
            var list = {
                type: "dec.loader.list",
                ref: function (_ref) {
                    self.list = _ref;
                },
                itemsCreator: function (op, callback) {
                    self.store.initItems(callback);
                },
                // items: self.model.groupItems,
                items: [],
                el: {
                    type: "dec.client.api.group.item",
                    onDelete:function (id) {
                        self.store.deleteGroup(id);
                    },
                    onEdit:function (val) {
                        self._addOrEditPop(EDIT, function (val, callback) {
                            self.store.editGroup(val, callback);
                        }, val)
                    },
                },
                hasNext: function () {
                    return false;
                },
                listeners: [
                    {
                        eventName: "EVENT_CHANGE",
                        action: function (v) {
                            self.store.selectGroup(v);
                        }
                    }
                ]
            };
            return {
                type: "bi.absolute",
                items: [
                    {
                        el: {
                            type: "bi.vtape",
                            items: [
                                {
                                    el: header,
                                    height: 40,
                                },
                                {
                                    el: list,
                                },
                            ],
                        },
                        top: 0, bottom: 0, left: 10, right: 10,
                    }
                ]
            };


        },
        populate: function (items) {
            this.list.populate(items);
        },
        _addOrEditPop: function (type, onClickConfirm, info) {
            var self = this;
            var o = this.options;
            var pane = {
                type: "dec.client.widget.add.edit.popup",
                info: info,
                cardType: o.cardType,
                onClickConfirm: onClickConfirm,
                listeners: [
                    {
                        eventName: "EVENT_CLOSE",
                        action: function () {
                            BI.Popovers.remove(self.getName() + type);
                        }
                    }
                ]
            };
            BI.Popovers.create(self.getName() + type, {
                type: "bi.popover",
                header: type === EDIT ? BI.i18nText("Plugin-Dec-Management_Client_Pop_Title_Edit") : BI.i18nText("Plugin-Dec-Management_Client_Pop_Title_add"),
                body: pane,
                width: 500,
                height: 450,
                listeners: [
                    {
                        eventName: "EVENT_CLOSE",
                        action: function () {
                            BI.Popovers.remove(self.getName() + type);
                        }
                    }
                ]
            }).open(self.getName() + type);
        }
    });
    BI.shortcut("dec.client.api.group", apiGroup);
})();