;!(function () {
    var Model = BI.inherit(Fix.Model, {
        _init: function () {

        },

        state: function () {
            return {
                groups: [],
                popFlag: ""
            };
        },

        context: ["selectedGroup"],

        computed: {
            groupItems: function () {
                var self = this;
                return BI.map(this.model.groups, function (index, item) {
                    return BI.extend({
                        selected: item.id === self.model.selectedGroup.id
                    }, item);
                });
            }
        },

        watch: {},

        actions: {
            initData: function (callback) {
                BI.isFunction(callback) && callback()

            },
            initItems: function (callback) {
                var data = Dec.Utils.Client.Group.page(-1, 10, "");
                data.unshift(BI.deepClone(DecCst.client.nogroup));
                BI.some(data, function (index, item) {
                    if (item.id === this.model.selectedGroup.id) {
                        item.selected = true;
                        return true;
                    }
                }, this);
                //debugger
                this.model.groups = data;
                if (BI.isFunction(callback)) {
                    callback(data);
                } else {
                    this.setPopFlag();
                    this._checkSelectedGroup();
                }
            },

            addGroup: function (info, callback) {
                var self = this;
                var data = Dec.Utils.Client.Group.add(info);
                if (data.errorCode) {
                    callback(false, DecCst.client.formatMsg(data));
                    return;
                }
                this.initItems();
                callback(true);
            },
            setPopFlag: function () {
                this.model.popFlag = BI.UUID();
            },

            selectGroup: function (v) {
                var self = this;
                BI.some(self.model.groups, function (index, item) {
                    if (item.id === v) {
                        self.model.selectedGroup = {
                            id: v,
                            name: item.name,
                            description: item.description
                        };
                        return true;
                    }
                })
            },

            editGroup: function (val, callback) {
                var self = this;
                var data = Dec.Utils.Client.Group.update(val);
                if (data.errorCode) {
                    callback(false, DecCst.client.formatMsg(data));
                    return;
                }
                callback(true);
                BI.some(self.model.groups, function (index, item) {
                    if (val.id === item.id) {
                        item = BI.extend(item, data);
                        if (val.id === self.model.selectedGroup.id) {
                            self.model.selectedGroup.name = data.name;
                        }
                        return true;
                    }
                })
                self.setPopFlag();

            },

            deleteGroup: function (id, callback) {
                var self = this;
                var data = Dec.Utils.Client.Group.remove([id]);
                if (data === "success") {
                    BI.remove(self.model.groups, function (index, item) {
                        return item.id === id;
                    });
                    if (id === self.model.selectedGroup.id) {//删除的如果是当前选中的，则选中默认分组
                        self.model.selectedGroup = BI.deepClone(DecCst.client.nogroup);
                        this.initItems();
                    } else {
                        self.setPopFlag();
                    }
                }
            }
        },
        _checkSelectedGroup: function () {
            var match = BI.some(this.model.groups, function (index, item) {
                if (item.id === this.model.selectedGroup.id) {
                    item.selected = true;
                    return true;
                }
            }, this);
            if (!match) {
                this.model.selectedGroup = BI.deepClone(DecCst.client.nogroup)
            }
        }
    });
    BI.model("dec.model.client.api.group", Model);
}());
