;!(function () {
    var carrierSelector = BI.inherit(BI.Widget, {
        props: {},
        _store: function () {
            return BI.Models.getModel("dec.model.client.privilege.carrier.selector");
        },
        watch:{
            selectedTab: function (v) {
                this.tabs.setValue(v);
                this.tab.setSelect(v);
            },
        },
        render: function () {
            var self = this, o = this.options;
            this.nav = {
                type: "dec.line_segment",
                ref: function (_ref) {
                    self.tabs = _ref;
                },
                cls: "dec-font-weight-bold",
                height: 40,
                items: this.model.tabs,
                itemHgap: 15,
                listeners: [{
                    eventName: "EVENT_CHANGE",
                    action: function (v) {
                        self.store.selectTab(v);
                    },
                }],
                layouts: [
                    {
                        type: "bi.vertical_adapt",
                    },
                ],
            };
            return {
                type: "bi.vtape",
                items: [
                    {
                        el: self.nav,
                        height: 40
                    }, {
                        el: {
                            type: "bi.absolute",
                            cls: "bi-border-top",
                            items: [
                                {
                                    el: {
                                        type: "bi.tab",
                                        ref: function (_ref) {
                                            self.tab = _ref;
                                        },
                                        showIndex: BI.Constants.getConstant("dec.constant.client.privilege.carrier.type")[0].value,
                                        cardCreator: BI.bind(this._createTab, this),
                                    },
                                    top: 0,
                                    right: 0,
                                    bottom: 0,
                                    left: 0,
                                },
                            ],
                            vgap: 10,
                        }
                    }
                ]
            }
        },
        _createTab: function (v) {
            var found = BI.find(BI.Constants.getConstant("dec.constant.client.privilege.carrier.type"), function (index, tab) {
                return tab.value === v;
            });

            return found ? {
                type: found.cardType,
                text: found.text
            } : {
                type: "bi.label",
                text: v,
            };
        }
    });
    BI.shortcut("dec.client.privilege.carrier.selector", carrierSelector);
})();