;!(function () {
    /**
     * 日了狗了，这个默认展开想改要改太多地方了，异步加载，异步刷新，前言万语汇做一句cnm
     */
    var Model = BI.inherit(Fix.Model, {
        _init: function () {
        },
        state: function () {
            return {
                items: [],
                privileges: [],
                itemsCreator:BI.emptyFn
            };
        },
        computed: {},
        context: ["carrierInfo", "carrierId", "groupItems", "clientItems"],
        watch: {
            "carrierInfo.id": function () {
                if (this.model.carrierInfo.carrierType === "client") {
                    this.initData();
                }
            }
        },
        actions: {
            initData: function (callback) {
                var self = this;

                self.model.privileges = BI.map(Dec.Utils.Client.Privilege.get(1, self.model.carrierInfo.id), function (index, item) {
                    return item.apiId;
                });


                var result = [];
                var groups = this.model.groupItems;
                BI.each(groups, function (index, group) {
                    var id = group.id;
                    var apis = Dec.Utils.Client.Relation.get(id);
                    var parentPrivilege = apis.length > 0;


                    BI.each(apis, function (index, api) {
                        var hasPrivilege = true;
                        if (!BI.contains(self.model.privileges, api.id)) {
                            parentPrivilege = false;
                            hasPrivilege = false;
                        }
                        result.push({id: api.id, pId: id, text: api.name, isParent: false, hasPrivilege: hasPrivilege}) //记得注释这行
                    })
                    

                    result.push({id: id, open: true, text: group.name, isParent: true, hasPrivilege: parentPrivilege});
                });
                self.model.items = result;
                self.model.itemsCreator = function(op, callback){
                    nodeResult = [];
                    if(op.node){
                        var id = op.node.id;
                        var apis = Dec.Utils.Client.Relation.get(id);
                        var parentPrivilege = apis.length > 0;


                        BI.each(apis, function (index, api) {
                            var hasPrivilege = true;
                            if (!BI.contains(self.model.privileges, api.id)) {
                                parentPrivilege = false;
                                hasPrivilege = false;
                            }
                            nodeResult.push({
                                type:"dec.client.privilege.tree.item",
                                id: api.id,
                                pId: id,
                                text: api.name,
                                layer: 1,
                                showPrivilegeIcon:true,
                                isParent: false,
                                hasPrivilege: hasPrivilege,
                                changePrivilege:self.setPrivilege,
                                baseCls: "piont-client bi-list-item",
                        })
                            //result.push({id: api.id, pId: id, text: api.name, isParent: false, hasPrivilege: hasPrivilege})
                        })


                    }
                    //callback(nodeResult);
                }
                BI.isFunction(callback) && callback();
            },
            setPrivilege: function (id, hasPrivilege, isParent) {
                var self = this;
                if (!BI.isKey(self.model.carrierInfo.id)) {
                    BI.Msg.toast(BI.i18nText("Plugin-Dec-Management_Client_Privilege_Client_Select"));
                    return;
                }
                if (isParent) {//父节点
                    var ids = [];//所有子节点
                    var dealNodes = [];
                    BI.each(self.model.items, function (index, item) {
                        if (item.pId === id) {
                            ids.push(item.id);
                            dealNodes.push(item);
                        }
                        if (item.id === id) {
                            dealNodes.push(item);
                        }
                    });
                    if (hasPrivilege) {//增加
                        Dec.Utils.Client.Privilege.set([{type: 1, id: self.model.carrierInfo.id, list: ids}], []);
                    } else {//删除
                        Dec.Utils.Client.Privilege.set([], [{type: 1, id: self.model.carrierInfo.id, list: ids}]);
                    }
                    self.initData();//不管了 重新后台刷新吧
                    /*                   BI.each(dealNodes, function (index, item) {
                                           item.hasPrivilege = hasPrivilege;
                                       });
                                       self.model.items.splice(0, 0);*/
                } else {
                    if (hasPrivilege) {//增加
                        Dec.Utils.Client.Privilege.set([{type: 1, id: self.model.carrierInfo.id, list: [id]}], []);
                    } else {//删除
                        Dec.Utils.Client.Privilege.set([], [{type: 1, id: self.model.carrierInfo.id, list: [id]}]);
                    }
                    self.initData();//不管了 重新后台刷新吧
                    // self.model.items.splice(0, 0);
                }

            }
        },
        _getCarrier: function (v) {
            return this.model.selectedCarriers[v];
        },
    })
    BI.model("dec.model.client.privilege.privilege.api", Model);

})();