;!(function () {
    var Model = BI.inherit(Fix.Model, {
        _init: function () {
        },
        state: function () {
            return {
                items: [],
                privileges: []
            };
        },
        computed: {},
        context: ["carrierInfo", "carrierId", "groupItems", "clientItems"],
        watch: {
            "carrierInfo.id": function () {
                if (this.model.carrierInfo.carrierType === "api") {
                    this.initData();
                }
            }
        },
        actions: {
            initData: function (callback) {

                var self = this;
                self.model.privileges = BI.map(Dec.Utils.Client.Privilege.get(0, self.model.carrierInfo.id), function (index, item) {
                    return item.clientId;
                });
                var result = [];
                var groups = this.model.groupItems;
                var id = "client-root-id";
                var parentPrivilege = true;
                var clients = self.model.clientItems;
                BI.each(clients, function (index, client) {
                    var hasPrivilege = true;
                    if (!BI.contains(self.model.privileges, client.id)) {
                        parentPrivilege = false;
                        hasPrivilege = false;
                    }
                    result.push({
                        id: client.id,
                        pId: id,
                        text: client.name,
                        isParent: false,
                        hasPrivilege: hasPrivilege
                    })
                })
                result.push({id: id, text: BI.i18nText("Plugin-Dec-Management_Client_Privilege_AllClinet"),open:true, isParent: true, hasPrivilege: parentPrivilege});
                self.model.items = result;
                BI.isFunction(callback) && callback();
            },
            setPrivilege: function (id, hasPrivilege, isParent) {
                var self = this;
                if (!BI.isKey(self.model.carrierInfo.id)) {
                    BI.Msg.toast(BI.i18nText("Plugin-Dec-Management_Client_Privilege_API_Select"))
                    return;
                }
                if (isParent) {//父节点
                    var ids = [];//所有子节点
                    var dealNodes = [];
                    BI.each(self.model.items, function (index, item) {
                        if (item.pId === id) {
                            ids.push(item.id);
                            dealNodes.push(item);
                        }
                        if (item.id === id) {
                            dealNodes.push(item);
                        }
                    });
                    if (hasPrivilege) {//增加
                        Dec.Utils.Client.Privilege.set([{type: 0, id: self.model.carrierInfo.id, list: ids}], []);
                    } else {//删除
                        Dec.Utils.Client.Privilege.set([], [{type: 0, id: self.model.carrierInfo.id, list: ids}]);
                    }
                    self.initData();//不管了 重新后台刷新吧
                    /*                   BI.each(dealNodes, function (index, item) {
                                           item.hasPrivilege = hasPrivilege;
                                       });
                                       self.model.items.splice(0, 0);*/
                } else {
                    if (hasPrivilege) {//增加
                        Dec.Utils.Client.Privilege.set([{type: 0, id: self.model.carrierInfo.id, list: [id]}], []);
                    } else {//删除
                        Dec.Utils.Client.Privilege.set([], [{type: 0, id: self.model.carrierInfo.id, list: [id]}]);
                    }
                    self.initData();//不管了 重新后台刷新吧
                    // self.model.items.splice(0, 0);
                }

            }
        },
        _getCarrier: function (v) {
            return this.model.selectedCarriers[v];
        },
    })
    BI.model("dec.model.client.privilege.privilege.client", Model);

})();