!(function () {
    var treeItem = BI.inherit(BI.BasicButton, {
        props: {
            baseCls: "piont-client bi-list-item-active",
            layer: 0, // 第几层级
            id: "",
            isParent:false,
            pId: "",
            height: 24,
            selected: false,
            showPrivilegeIcon: false,
            hasPrivilege: true,//是否有权限
            changePrivilege:BI.emptyFn,

        },


        render: function () {
            var self = this, o = this.options;
            var items = [];
            var editor = {
                type: "bi.shelter_editor",
                //  type:"bi.label",
                textAlign: "left",
                $value: o.text,
                ref: function (_ref) {
                    self.editor = _ref;
                },
                cls: "bi.border",
                height: o.height,
                text: o.text,
                value: o.text,
                keyword: o.keyword,
                allowBlank: false,
                // validationChecker: function (v) {
                //     return Dec.Utils.checkValidName(v);
                // },
                // errorText: BI.i18nText("Dec-Error_Name_Limit_Tip", BI.i18nText("Dec-Department_Name")),
                listeners: [
                    {
                        eventName: "EVENT_CLICK_LABEL",
                        action: function () {
                        }
                    }
                ]
            };
            BI.count(0, o.layer, function () {
                items.push({
                    type: "bi.layout",
                    cls: "base-line-conn-background",
                    width: 12,
                    height: o.height
                });
            });


            items.push({
                width: 24,
                el: {
                    type: "bi.layout",
                    cls: "mid-line-conn-background",
                    width: 24,
                    height: o.height
                }
            });
            items.push({
                el: editor,
                height: o.height
            });
            items.push({
                type: "bi.icon_change_button",
                invisible: !o.showPrivilegeIcon,
                width: 30,
                stopPropagation: true,

                ref: function (_ref) {
                    self.button = _ref;
                },
                $testId: "dec-checkbox-auth",
                value: o.value,
                iconCls: o.hasPrivilege ? "auth-on-font" : "auth-off-font",
                height: o.height,
                selected: o.hasPrivilege,
                listeners: [
                    {
                        eventName: BI.IconChangeButton.EVENT_CHANGE,
                        action: function () {
                            //debugger
                            self._handleClick();
                        },
                    },
                ],
            })

            return {
                type: "bi.htape",
                items: items
            };
        },
        isOpened: function () {
            return this.options.open;

        },
        setOpened: function (v) {
            this.options.open = v;
        },
        _handleClick: function () {
            this.options.hasPrivilege = !this.options.hasPrivilege;
            this._setIcon();
            this.fireEvent("PRIVILEGE_CHANGE", this.options.id,this.options.hasPrivilege,this.options.isParent);
            this.options.changePrivilege(this.options.id,this.options.hasPrivilege,this.options.isParent)

            // this.fireEvent(BI.Controller.EVENT_CHANGE, BI.Events.STATECHANGE, this.getValue(), this.isSelected(), this);
        },
        _setIcon: function () {
            var o = this.options;
            var cls = this.options.hasPrivilege ? "auth-on-font" : "auth-off-font";
            this.button.setIcon(cls);
            //   o.iconClass = cls;
        },

        isOnce: function () {
            return true;
        },

        getValue: function () {
            var self = this, o = this.options;
            return {
                id:o.id,
                isParent:o.isParent
            };
        },

        setSelected: function (b) {
            this.options.selected = b;
            treeItem.superclass.setSelected.apply(this, arguments);
        },

        doClick: function () {
            BI.NodeButton.superclass.doClick.apply(this, arguments);
        }
    });

    BI.shortcut("dec.client.privilege.tree.item", treeItem);
}());

