!(function () {
    var treeNode = BI.inherit(BI.NodeButton, {

        props: {
            baseCls: "piont-client",
            layer: 0, // 第几层级
            id: "",
            pId: "",
            open: false,
            isRoot: false,
            height: 24,
            pos: "first",
            selected: true,
            hasPrivilege: true,
            showPrivilegeIcon: false,
            status: false, //是否展开的状态

        },

        // mounted: function () {
        //     if (this.options.open) {
        //         this.triggerExpand();
        //     }
        // },

        render: function () {

            var self = this, o = this.options;

            var checkbox = {
                type: this._getShortcutByPos(),
                $value: o.text,
                ref: function (_ref) {
                    self.checkbox = _ref;
                },
                stopPropagation: true,
                listeners: [
                    {
                        eventName: "BasicButton.EVENT_CHANGE",
                        action: function () {
                            if (this.isSelected()) {
                                self.triggerExpand();
                            } else {
                                self.triggerCollapse();
                            }
                        }
                    }
                ]
            };
            var editor = {
                // type: "bi.shelter_editor",
                type: "bi.label",
                textAlign: "left",
                $value: o.text,
                ref: function (_ref) {
                    self.editor = _ref;
                },
                cls: "bi.border",
                height: o.height,
                text: o.text,
                value: o.text,
                keyword: o.keyword,
                allowBlank: false,
                listeners: [
                    {
                        eventName: "EVENT_CLICK_LABEL",
                        action: function () {
                            //debugger
                            // self.checkbox.fireEvent("BasicButton.EVENT_CHANGE");
                            // self.fireEvent("SELECT_CLICK", {value:o.id,allType:o.allType});
                        }
                    },
                    {
                        eventName: "PRIVILEGE_CHANGE",
                        action: function (id, hasPrivilege, isParent) {
                            //debugger
                            o.changePrivilege(id, hasPrivilege, isParent)
                        }
                    }
                ]
            };


            var items = [];
            BI.count(0, o.layer, function () {
                items.push({
                    type: "bi.layout",
                    cls: "base-line-conn-background",
                    width: 12,
                    height: o.height
                });
            });

            items.push({
                el: checkbox,
                width: 24,
                height: o.height
            });
            items.push({
                el: editor,
                height: o.height
            });
            items.push({
                type: "bi.icon_change_button",
                invisible: !o.showPrivilegeIcon,
                width: 30,
                stopPropagation: true,
                ref: function (_ref) {
                    self.button = _ref;
                },
                $testId: "dec-checkbox-auth",
                value: o.value,
                iconCls: o.hasPrivilege ? "auth-on-font" : "auth-off-font",
                height: o.height,
                selected: o.hasPrivilege,
                listeners: [
                    {
                        eventName: BI.IconChangeButton.EVENT_CHANGE,
                        action: function () {
                            self._handleClick();
                        },
                    },
                ],
            })

            BI.createWidget({
                type: "bi.htape",
                element: this,
                items: items
            });
        },
        isOpened: function () {
            return this.options.open;

        },
        _handleClick: function () {
            this.options.hasPrivilege = !this.options.hasPrivilege;
            this._setIcon();
            this.fireEvent("PRIVILEGE_CHANGE", this.options.id, this.options.hasPrivilege, this.options.isParent);
            // this.fireEvent(BI.Controller.EVENT_CHANGE, BI.Events.STATECHANGE, this.getValue(), this.isSelected(), this);
        },
        _setIcon: function () {
            var o = this.options;
            var cls = this.options.hasPrivilege ? "auth-on-font" : "auth-off-font";
            this.button.setIcon(cls);
            //   o.iconClass = cls;
        },
        _getShortcutByPos: function () {
            switch (this.options.pos) {
                case "first":
                    return "bi.first_tree_node_checkbox";
                case "mid":
                    return "bi.mid_tree_node_checkbox";
                case "last":
                    return "bi.last_tree_node_checkbox";
                default:
                    break;
            }
        },

        isOnce: function () {
            return true;
        },

        getValue: function () {
            var self = this, o = this.options;
            return {
                id: o.id,
                isParent: o.isParent
            };
        },
        setSelected: function (b) {
            //   treeNode.superclass.setSelected.apply(this, arguments);
        },

        doClick: function () {
            //  BI.NodeButton.superclass.doClick.apply(this, arguments);
        },

        setOpened: function (v) {
            treeNode.superclass.setOpened.apply(this, arguments);
            this.options.open = v;
            if (BI.isNotNull(this.checkbox)) {
                this.checkbox.setSelected(v);
            }
        }
    });

    BI.shortcut("dec.client.privilege.tree.node", treeNode);
}());

