;!(function () {
    var privilegeTree = BI.inherit(BI.Widget, {

        props: {
            //   baseCls: "dec-user-department-tape",
            firstType: "dec.client.privilege.tree.node",
            lastType: "dec.client.privilege.tree.item",
            showPrivilegeIcon: true,//是否显示权限控制图标
            changePrivilege: BI.emptyFn,
            selectValue: BI.emptyFn,
            items: [],
            itemsCreator:BI.emptyFn,
            nodeCls:""
        },

        _store: function () {
            return BI.Models.getModel("dec.model.client.privilege.tree", {
                items: this.options.items,
                itemsCreator: this.options.itemsCreator
            });
        },
        beforeInit: function (callback) {
            this.store.initRootNodes(callback);
        },

        watch: {
            items: function () {
                if (!this.model.isLoading) {
                    this.populate(this.model.items);
                }
                this.model.isLoading = false;
            },
            selectMetrics: function (v) {
                this.tree.setValue(v);
            }
        },
        render: function () {
            var self = this, o = this.options;
            //debugger
            var tree = {
                type: "bi.custom_tree",
                ref: function (_ref) {
                    self.tree = _ref;
                },
                cls: "decision-user-department-select-tree",
                expander: {
                    //     type: "bi.select_tree_expander",
                    type: "bi.expander",
                    isDefaultInit: false,
                    el: {},
                    popup: {
                        type: "bi.custom_tree"
                    }
                },
                items: self._dealItems(self.model.items),
                el: {
                    type: "bi.loader",
                    next: false,
                    el:{
                        type: "bi.button_tree",
                        chooseType: -1,
                        layouts: [{
                            type: "bi.vertical"
                        }]
                    }

                },
                itemsCreator: BI.bind(o.itemsCreator,this),
                listeners: [
                    {
                        eventName: "EVENT_CHANGE",
                        action: function (v) {
                            self.store.selectMetrics(v);
                            o.selectValue(v);
                        }
                    }, {
                        eventName: BI.Controller.EVENT_CHANGE,
                        action: function (type, value) {
                            if (type === BI.Events.EXPAND) {
                                self.store.updateOpenStatus(value, true);
                            }
                            if (type === BI.Events.COLLAPSE) {
                                self.store.updateOpenStatus(value, false);
                            }
                        }
                    }
                ]
            };
            return {
                type: "bi.absolute",
                items: [
                    {
                        el: {
                            type: "bi.vtape",
                            items: [
                                {
                                    type: "bi.absolute",
                                    items: [
                                        {
                                            el: tree,
                                            top: 0, left: 0, right: 0, bottom: 0
                                        }
                                    ]
                                }
                            ],
                            width: o.width
                        },
                        left: 10, right: 10, top: 0, bottom: 10
                    }
                ]
            };
        },

        // 解析单层数结构
        _formatItems: function (nodes, layer) {
            var self = this, o = this.options;
            nodes = BI.deepClone(nodes);
            BI.each(nodes, function (i, node) {

                var extend = {
                    layer: layer,
                };
                extend.listeners = [
                    {
                        eventName: "PRIVILEGE_CHANGE",
                        action: function (id, hasPrivilege, isParent) {
                            o.changePrivilege(id, hasPrivilege, isParent)
                        }
                    }
                ]

                if (node.isParent === true) {
                    extend.type = o.firstType;
                    switch (i) {
                        case 0 :
                            extend.pos = "first";
                            break;
                        case nodes.length - 1 :
                            extend.pos = "last";
                            break;
                        default :
                            extend.pos = "mid";
                            break;
                    }
                    BI.defaults(node, extend);
                } else {
                    extend.type = o.lastType;
                    switch (i) {
                        case nodes.length - 1:
                            extend.pos = "last";
                            break;
                        default :
                            extend.pos = "mid";
                    }
                    BI.defaults(node, extend);
                }
            });

            return nodes;
        },

        // 解析层级结构的树数据.即带有children字段的
        _formatTreeItems: function (nodes, layer) {
            var self = this, o = this.options;
            BI.each(nodes, function (i, node) {
                /* if(o.otherAttr){
                     node=$.extend(o.otherAttr,node);
                 }*/
                var extend = {
                    layer: layer,
                };
                extend.listeners = [
                    {
                        eventName: "PRIVILEGE_CHANGE",
                        action: function (id, hasPrivilege, isParent) {
                            o.changePrivilege(id, hasPrivilege, isParent)
                        }
                    }
                ]
                extend.showPrivilegeIcon = o.showPrivilegeIcon;
                if(o.nodeCls != ""){
                    extend.baseCls = o.nodeCls
                }
                if (node.isParent === true || BI.isNotEmptyArray(node.children)) {
                    extend.type = o.firstType;
                    switch (i) {
                        case 0 :
                            extend.pos = "first";
                            break;
                        case nodes.length - 1 :
                            extend.pos = "last";
                            break;
                        default :
                            extend.pos = "mid";
                            break;
                    }
                    BI.defaults(node, extend);
                    self._formatTreeItems(node.children, layer + 1);
                } else {
                    extend.type = o.lastType;
                    extend.cls = o.showPrivilegeIcon ? "" : "last-item bi-list-item-active2";
                    switch (i) {
                        case nodes.length - 1:
                            extend.pos = "last";
                            break;
                        default :
                            extend.pos = "mid";
                    }
                    BI.defaults(node, extend);
                }
            });
        },
        _dealItems: function (nodes) {
            var self = this;
            nodes = BI.deepClone(nodes);
            BI.each(nodes, function (index, item) {
                item.selected = item.id === this.model.selectMetrics.id;
                if (BI.isUndefined(item.open) && item.isParent) {
                    item.open = (self.model.openStaus)[item.id];
                }
            }, this);
            var items = BI.Tree.transformToTreeFormat(nodes);
            this._formatTreeItems(items, 0);
            return items;
        },
        populate: function (nodes) {
            this.tree.populate(this._dealItems(nodes));
        }
    });
    BI.shortcut("dec.client.privilege.tree", privilegeTree);
})();