!(function () {
    var lineChart = BI.inherit(BI.Widget, {
        beforeInit: function (callback){
            var self = this;
            self.store._init(callback);
        },
        _store: function () {
            return BI.Models.getModel("dec.client.watcher.lineChart.model");
        },
        mounted: function () {
            var self = this;
            var myChart = echarts.init(this.element[0]);
            var option = (option = {
                title: {
                    text: BI.i18nText("Plugin-Dec-Chart-API-Request-Frequency"),
                    subtext:BI.i18nText("Plugin-Dec-Chart-Step-Per-Minute")
                },
                tooltip: {
                    trigger: "axis",
                },

                xAxis: {
                    type: "category",
                    boundaryGap: false,
                    data: this.model.xAxis
                },
                yAxis: {
                    type: "value",
                    axisLabel: {
                        formatter: "{value}",
                    },
                },
                series: [
                    {
                        name: BI.i18nText("Plugin-Dec-Chart-Request-Per-Minute"),
                        type: "line",
                        data: this.model.data,
                        markPoint: {
                            data: [
                                { type: "max", name: BI.i18nText("Plugin-Dec-Chart-Max") },
                            ],
                        },
                        markLine: {
                            data: [{ type: "average", name: BI.i18nText("Plugin-Dec-Chart-AVE") }],
                        },

                        smooth:  0.6,
                    }
                ],
            });

            // 使用刚指定的配置项和数据显示图表。
            myChart.setOption(option);
        },
    });

    BI.shortcut("dec.client.watcher.lineChart", lineChart);
}());

