;!(function () {
    var EDIT = "edit", ADD = "add";
    var widget = BI.inherit(BI.Widget, {
        props: {
            perPage: 10,
            showTools: false,
            limited: false,
            columnSize: [],
            header: [],
            itemsCreateFn: BI.emptyFn,

            cardWidth: 500,
            cardHeight: 450,
            showTrans: false,


            customFormat: function (vals) {
                return vals;
            }
        },
        _store: function () {
            var o = this.options;

            return BI.Models.getModel("dec.client.watcher.table.model", {
                perPage: o.perPage,
                itemsCreateFn: o.itemsCreateFn,

            });
        },
        watch: {
            count: function (v) {
                this.table.setCount(v);
            },
            items: function () {
                this.populate(this.model.items);
                this.table.setPage(this.model.page);
            },
            page: function () {
                this.table.setPage(this.model.page);
            },
            perPage: function (v) {
                this.table.attr("perPage", v);
                this.store.setPage(1);
                this.reload();
                this.table.setCount(this.model.count);
                this.table.reloadPage();
                this.populate(this.model.items);
            }
        },
        beforeInit: function (callback) {
            // this.store.initData(callback)
            callback();
        },
        beforeDestroy: function () {
            BI.Resizers.remove(this.getName());
        },
        /**
         * 写在这个地方确实有点不舒服，但也没啥好办法  长宽属性在beforeinit里拿不到
         */
        mounted: function () {
            /*            var self = this;
                        this.table.setCount(this.model.count);
                        this.populate(this.formatItems(this.model.items));*/
            var self = this;
            this.store.updateUserListHeight(this._calculateUserListHeight());
            BI.Resizers.add(this.getName(), function () {
                self.store.updateUserListHeight(self._calculateUserListHeight());
            });
        },
        render: function () {
            var self = this, o = this.options;

            this.table = BI.createWidget({
                //   type: "dec.check.page.table",
                type: "dec.check.page.table.base",
                header: o.header,
                columnSize: o.columnSize,
                perPage: self.model.perPage,
                showCheckBox:false,
                listeners: [{
                    eventName: "EVENT_CHANGE",
                    action: function (v) {
                        self.store.setPage(v);
                    }
                }]
            });

            return {
                type: "bi.vtape",
                hgap: 10,
                items: [{
                        el: this.table
                    }]
            };
        },
        populate: function (vals) {
            this.table.populate(vals);
        },

        _addOrEditPop: function (type, onClickConfirm, info) {
            var self = this;
            var o = this.options;
            var pane = {
                type: "dec.client.widget.add.edit.popup",
                info: info,
                cardType: o.cardType,
                onClickConfirm: onClickConfirm,
                listeners: [
                    {
                        eventName: "EVENT_CLOSE",
                        action: function () {
                            BI.Popovers.remove(self.getName() + type);
                        }
                    }
                ]
            };
            BI.Popovers.create(self.getName() + type, {
                type: "bi.popover",
                header: type === EDIT ? BI.i18nText("Plugin-Dec-Management_Client_Pop_Title_Edit") : BI.i18nText("Plugin-Dec-Management_Client_Pop_Title_add"),
                body: pane,
                width: o.cardWidth,
                height: o.cardHeight,
                listeners: [
                    {
                        eventName: "EVENT_CLOSE",
                        action: function () {
                            BI.Popovers.remove(self.getName() + type);
                        }
                    }
                ]
            }).open(self.getName() + type);
        },
        _calculateUserListHeight: function () {
            //  容器高度-工具栏-(表头+页码)
            return this.element.height() - 40 - 82;
        },
        reload: function () {
            this.store.initData();
        }

    });
    BI.shortcut("dec.client.watcher.table", widget);
})();