!(function () {
    var Header = BI.inherit(BI.Widget, {

        props: {
            baseCls: "dec-page-table-header",
            items: [],
            columnSize: [],
            showCheckBox: true,
        },

        _store: function () {
            return BI.Models.getModel("dec.model.check.page.table.header.base");
        },

        watch: {
            sort: function (val) {
                var self = this;
                BI.each(this.sortabeld, function (i, v) {
                    if (v !== val.columnName) {
                        self["sort_" + v].restore();
                    }
                });
            },

            "pageIds || selectedState": function () {
                if(this.options.showCheckBox){
                    this.checkbox.setSelected(this.model.selectedState === BI.Selection.All);
                    this.checkbox.setHalfSelected(this.model.selectedState === BI.Selection.Multi);
                }

            },
        },

        render: function () {
            var self = this, o = this.options;
            this.sortabeld = [];
            var items = [];
            if(o.showCheckBox){
                items.push({
                    type: "dec.multi.checkbox",
                    width: 36,
                    height: 32,
                    ref: function (_ref) {
                        self.checkbox = _ref;
                    },
                    listeners: [{
                        eventName: BI.MultiSelectBar.EVENT_CHANGE,
                        action: function () {
                            self.store.setSelectedAll(this.isSelected());
                        },
                    }],
                })
            }
            items.push({
                type: "bi.td",
                columnSize: o.columnSize,
                items: [self._createItems()],
            })
            return {
                type: "bi.htape",
                height: 32,
                items:items,
            };
        },

        _createItems: function () {
            var self = this, o = this.options, index = 0;

            return BI.map(o.items, function (i, v) {
                var res = {
                    text: v.text,
                    textAlign: "left",
                    lgap: index++ > 0 ? 10 : 0,
                    height: 32,
                };
                if (v.sortable === true) {
                    self.sortabeld.push(v.value);

                    return BI.extend({
                        type: "dec.page.table.sortable.label",
                        ref: function (_ref) {
                            self["sort_" + v.value] = _ref;
                        },
                        listeners: [{
                            eventName: "EVENT_CHANGE",
                            action: function (sort) {
                                self.store.setSort(v.value, sort);
                            },
                        }],
                    }, res);
                }

                return {
                    el: BI.extend({
                        type: "bi.label",
                    }, res),
                };
            });
        },
    });
    BI.shortcut("dec.check.page.table.header.base", Header);
}());
!(function () {
    var Model = BI.inherit(Fix.Model, {

        context: ["sort", "pageIds", "selectedIds"],

        computed: {
            selectedState: function () {
                if (BI.size(this.model.selectedIds) === 0) {
                    return BI.Selection.None;
                }
                if (BI.size(this.model.selectedIds) === BI.size(this.model.pageIds)) {
                    return BI.Selection.All;
                }

                return BI.Selection.Multi;
            },
        },

        actions: {
            setSelectedAll: function (v) {
                this.model.selectedIds = v ? BI.deepClone(this.model.pageIds) : [];
            },

            setSort: function (type, desc) {
                this.model.sort = {
                    columnName: type,
                    desc: desc === 1,
                };
            },
        },
    });
    BI.model("dec.model.check.page.table.header.base", Model);
}());
