!(function () {
    var Row = BI.inherit(BI.Widget, {

        props: {
            baseCls: "dec-page-table-row",
            item: {},
            id: BI.UUID(),
            columnSize: [],
            odd: false,
            canSelect: true,
            showCheckBox: true,
        },

        _store: function () {
            return BI.Models.getModel("dec.model.check.page.table.row.base", {
                id: this.options.id,
            });
        },

        watch: {
            isSelected: function (v) {
                this.options.showCheckBox&&this.checkbox.setSelected(v);
            },
        },

        render: function () {
            var self = this, o = this.options, index = 0;
            var items = [];
            if(o.showCheckBox){
                items.push({
                    type: "bi.checkbox",
                    width: 36,
                    disabled: !o.canSelect,//添加一个是否可以选中的控制
                    height: 32,
                    ref: function (_ref) {
                        self.checkbox = _ref;
                    },
                    handler: function () {
                        self.store.setSelected(this.isSelected());
                    },
                })
            }
            items.push({
                type: "bi.td",
                columnSize: o.columnSize,
                items: [BI.map(o.item, function (i, v) {
                    return BI.isPlainObject(v) ? BI.createWidget(v) : {
                        type: "bi.htape",
                        height: 32,
                        items: [{
                            el: {
                                type: "bi.label",
                                text: v,
                                title: v,
                                textAlign: "left",
                                height: 32,
                            },
                            lgap: index++ > 0 ? 10 : 0,
                        }],
                    };
                })],
            });
            return {
                type: "bi.htape",
                height: 32,
                cls: o.odd ? "row-odd" : "row-even",
                items: items
            };
        },
    });
    BI.shortcut("dec.check.page.table.row.base", Row);
}());
!(function () {
    var Model = BI.inherit(Fix.Model, {
        context: ["sort", "pageIds", "selectedIds"],

        state: function () {
            return {
                id: this.options.id,
            };
        },

        computed: {
            isSelected: function () {
                return BI.contains(this.model.selectedIds, this.model.id);
            },
        },

        actions: {
            setSelected: function (v) {
                v ? this.model.selectedIds.push(this.model.id) : BI.remove(this.model.selectedIds, this.model.id);
            },
        },
    });
    BI.model("dec.model.check.page.table.row.base", Model);
}());
