!(function () {


    var addPopup = BI.inherit(BI.Widget, {

        props: {

            btns: [BI.i18nText(BI.i18nText("Dec-Basic_Sure")), BI.i18nText(BI.i18nText("Dec-Basic_Cancel"))],
            onClickConfirm: BI.emptyFn,
            info: {},
            cardType: "bi.layout"
        },

        render: function () {
            var self = this, o = this.options;
            return {
                type: "bi.vtape",
                items: [
                    {
                        el: {
                            type: o.cardType,
                            info: o.info,
                            ref: function (_ref) {
                                self.card = _ref;
                            }
                        }
                    }, {
                        el: this.rebuildSouth(),
                        height: 44
                    }
                ]
            };
        },


        rebuildSouth: function () {
            var self = this, o = this.options;
            var sure = BI.createWidget({
                type: "bi.button",
                ref: function (_ref) {
                    self.sure = _ref;
                },
                text: this.options.btns[0],
                warningTitle: o.warningTitle,
                height: 24,
                handler: function () {
                    self.end();
                }
            });
            var cancel = BI.createWidget({
                type: "bi.button",
                ref: function (_ref) {
                    self.cancel = _ref;
                },
                text: this.options.btns[1],
                height: 24,
                level: "ignore",
                handler: function () {
                    self.close();
                }
            });
            return {
                type: "bi.right_vertical_adapt",
                lgap: 10,
                items: [cancel, sure]
            };
        },


        _quitChecker: function () {
            if (BI.isFunction(this.card.checkValue)) {
                var result = this.card.checkValue();
                if (!result.status) {
                    BI.Msg.toast(result.errorMsg, {level: "error"});
                    return false;
                }
            }
            return true;//不设置 默认不校验
        },

        getValue: function () {

            return this.card.getValue();
        },

        setValue: function (info) {
            this.card.setValue(info);
        },

        close: function () {
            this.fireEvent("EVENT_CLOSE");
        },
        end: function () {
            var self = this;
            if (BI.isFunction(this.card.isEditable) && (!this.card.isEditable())) {
                this.fireEvent("EVENT_CLOSE");
                return;
            }
            if (this._quitChecker()) {
                this.options.onClickConfirm(this.getValue(), function (isSuccess, errorMsg) {
                    if (isSuccess) {
                        self.close();
                    } else {
                        //self.departmentName.showError(BI.i18nText("Dec-Error_Duplicate_Department_Names"));
                        BI.Msg.toast(BI.i18nText("Plugin-Dec-Name-Repeat"), {level: "error"})
                    }
                });
            }
        }
    });
    BI.shortcut("dec.client.widget.add.edit.popup", addPopup);
}());