;!(function () {

    var configList = BI.inherit(BI.Widget, {
        props: {
            baseCls: "dec-parameter-list",
            $testId: "dec-parameter-list",
            width: 500,
            editorWidth: 100,
            items: [],
            blockSize: 4,
            pathGetter: BI.emptyFn
        },
        _store: function () {
            return BI.Models.getModel("dec.model.client.widget.config.parameter.list", {
                parameters: this.options.items
            })
        },
        watch: {
            parameters: function () {
                this.list.populate(this._createItems(this.model.parameters))
            }
        },
        mounted: function () {
            this.options.blockSize && this.list && this.list.element.css("maxHeight", 36 * this.options.blockSize + 4)
        },
        render: function () {
            var self = this
                , o = this.options;
            return {
                type: "bi.vertical",
                items: [{
                    el: {
                        type: "bi.vertical",
                        cls: "bi-border",
                        ref: function (_ref) {
                            self.parameter = _ref
                        },
                        items: [{
                            type: "bi.htape",
                            cls: "dec-parameter-list-header bi-background",
                            width: o.width,
                            height: 32,
                            items: [{
                                type: "bi.htape",
                                items: [{
                                    el: {
                                        type: "bi.label",
                                        textAlign: "left",
                                        text: BI.i18nText("Dec-Basic_Name"),
                                        lgap: 10,
                                        height: 32
                                    },
                                    width: 0.5
                                }, {
                                    el: {
                                        type: "bi.label",
                                        textAlign: "left",
                                        text: BI.i18nText("BI-Basic_Value"),
                                        height: 32
                                    },
                                    width: 0.5
                                }]
                            }, {
                                type: "bi.center_adapt",
                                items: [{
                                    type: "bi.icon_button",
                                    $value: "plus",
                                    width: 24,
                                    height: 24,
                                    cls: "plus-font",
                                    handler: function () {
                                        self.store.addParameterItem()
                                    }
                                }],
                                width: 60
                            }]
                        }, {
                            type: "bi.button_group",
                            ref: function (_ref) {
                                self.list = _ref
                            },
                            layouts: [{
                                type: "bi.vertical"
                            }],
                            items: this._createItems(this.model.parameters)
                        }]
                    }
                }]
            }
        },
        _createItems: function (items) {
            var self = this
                , o = this.options
                , cloneItems = BI.deepClone(items);
            return BI.map(cloneItems, function (index, item) {
                return BI.defaults({
                    type: "dec.client.widget.config.parameter.item",
                    editorWidth: o.editorWidth,
                    id: index,
                    handleDelete: BI.bind(self._deleteItem, self, index),
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function (id, value) {
                            self.store.changeParameterItem(id, value),
                                self.fireEvent("EVENT_CHANGE", self.getValue())
                        }
                    }]
                }, item)
            })
        },
        _deleteItem: function (id) {
            this.store.deleteItem(id),
                this.fireEvent("EVENT_DELETE", id)
        },
        getValue: function () {
            return this.model.parameters;
        },
        populate: function (items) {
            this.store.resetParameters(BI.deepClone(items))
        }
    });
    BI.shortcut("dec.client.widget.config.parameter.list", configList);


    var Model = BI.inherit(Fix.Model, {
        _init: function () {
        },
        state: function () {
            return {
                parameters: this.options.parameters
            }
        },
        computed: {},
        watch: {},
        actions: {
            addParameterItem: function (item) {
                this.model.parameters.push({})
            },
            resetParameters: function (items) {
                this.model.parameters = items
            },
            changeParameterItem: function (id, val) {
                BI.some(this.model.parameters, function (index, item) {
                    index === id && BI.extend(item, val)
                })
            },
            deleteItem: function (id) {
                this.model.parameters.splice(id, 1)
            }
        }
    });
    BI.model("dec.model.client.widget.config.parameter.list", Model)
})();