;!(function () {
    var EDIT = "edit", ADD = "add";
    var widget = BI.inherit(BI.Widget, {
        props: {
            perPage: 10,
            showTools: false,
            limited: false,
            columnSize: [],
            header: [],
            itemsCreateFn: BI.emptyFn,
            addItemFn: BI.emptyFn,
            deleteItemFn: BI.emptyFn,
            updateItemFn: BI.emptyFn,
            transferAPIFn: BI.emptyFn,
            cardWidth: 500,
            cardHeight: 450,
            showTrans: false,


            customFormat: function (vals) {
                return vals;
            }
        },
        _store: function () {
            var o = this.options;

            return BI.Models.getModel("dec.model.client.widget.table", {
                perPage: o.perPage,
                itemsCreateFn: o.itemsCreateFn,
                addItemFn: o.addItemFn,
                deleteItemFn: o.deleteItemFn,
                updateItemFn: o.updateItemFn,
                transferAPIFn: o.transferAPIFn
            });
        },
        watch: {
            count: function (v) {
                this.table.setCount(v);
            },
            items: function () {
                this.populate(this.formatItems(this.model.items));
                this.table.setPage(this.model.page);
            },
            page: function () {
                this.table.setPage(this.model.page);
            },
            perPage: function (v) {
                this.table.attr("perPage", v);
                this.store.setPage(1);
                this.reload();
                this.table.setCount(this.model.count);
                this.table.reloadPage();
                this.populate(this.formatItems(this.model.items));
            }
        },
        beforeInit: function (callback) {
            // this.store.initData(callback)
            callback();
        },
        beforeDestroy: function () {
            BI.Resizers.remove(this.getName());
        },
        /**
         * 写在这个地方确实有点不舒服，但也没啥好办法  长宽属性在beforeinit里拿不到
         */
        mounted: function () {
            /*            var self = this;
                        this.table.setCount(this.model.count);
                        this.populate(this.formatItems(this.model.items));*/
            var self = this;
            this.store.updateUserListHeight(this._calculateUserListHeight());
            BI.Resizers.add(this.getName(), function () {
                self.store.updateUserListHeight(self._calculateUserListHeight());
            });
        },
        render: function () {
            var self = this, o = this.options;
            this.toolbar = BI.createWidget({
                type: "bi.button_group",
                layouts: [
                    {
                        type: "bi.vertical_adapt",
                        rgap: 15
                    }
                ],
                items: this._createOperations()
            });

            this.table = BI.createWidget({
                //   type: "dec.check.page.table",
                type: "dec.check.page.table.base",
                header: o.header,
                columnSize: o.columnSize,
                perPage: self.model.perPage,
                listeners: [{
                    eventName: "EVENT_CHANGE",
                    action: function (v) {
                        self.store.setPage(v);
                    }
                }]
            });
            return {
                type: "bi.vtape",
                hgap: 10,
                items: [
                    {
                        type: "bi.absolute",
                        height: 40,
                        items: [
                            {
                                el: this.toolbar,
                                top: 0, left: 0, bottom: 0
                            }
                        ]
                    }, {
                        el: this.table
                    }]
            };
        },
        populate: function (vals) {
            this.table.populate(vals);
        },
        _createOperations: function () {
            var self = this;
            var o = this.options;
            var result = [{
                value: "add",
                type: "bi.icon_text_item",
                text: BI.i18nText("Plugin-Dec-Management_Client_Add"), cls: "text-add-tip-font",
                logic: {
                    dynamic: true
                },
                listeners: [
                    {
                        eventName: "EVENT_CHANGE",
                        action: function () {
                            self._addOrEditPop(ADD, function (val, callback) {
                                self.store.addItem(val, callback)
                            })
                        }
                    }
                ],
                rgap: 20
            }, {
                value: "delete",
                text: BI.i18nText("Plugin-Dec-Management_Client_Delete"),
                type: "bi.icon_text_item",
                cls: "delete-font-red operation-item",
                logic: {
                    dynamic: true
                },
                listeners: [
                    {
                        eventName: "EVENT_CHANGE",
                        action: function () {
                            BI.Msg.confirm(BI.i18nText("Plugin-Dec-Management_Client_Delete"), BI.i18nText("Plugin-Dec-Management_Client_Delete-Select-Confirm"), function (v) {
                                if (v) {
                                    self.store.deleteItems(self.table.getValue());
                                }
                            })

                        }
                    }
                ],
                rgap: 20
            }];
            if (o.showTrans) {
                result.push({
                    value: "transfot",
                    text: BI.i18nText("Plugin-Dec-Management_Client_Change_Group"),
                    type: "bi.icon_text_item",
                    cls: "date-change-h-font",
                    logic: {
                        dynamic: true
                    },
                    listeners: [
                        {
                            eventName: "EVENT_CHANGE",
                            action: function () {
                                var type = "trans";
                                var pane = {
                                    type: "dec.client.widget.add.edit.popup",
                                    info: {},
                                    cardType: "dec.api.transfer.info",
                                    onClickConfirm: function (val, callback) {
                                        var ids = self.table.getValue();
                                        self.store.apiTransferGroup(ids, val, callback);
                                    },
                                    listeners: [
                                        {
                                            eventName: "EVENT_CLOSE",
                                            action: function () {
                                                BI.Popovers.remove(self.getName() + type);
                                            }
                                        }
                                    ]
                                };
                                BI.Popovers.create(self.getName() + type, {
                                    type: "bi.popover",
                                    header:  BI.i18nText("Plugin-Dec-Management_Client_Change_Group"),
                                    body: pane,
                                    width: o.cardWidth,
                                    height: o.cardHeight,
                                    listeners: [
                                        {
                                            eventName: "EVENT_CLOSE",
                                            action: function () {
                                                BI.Popovers.remove(self.getName() + type);
                                            }
                                        }
                                    ]
                                }).open(self.getName() + type);
                            }
                        }
                    ],
                    rgap: 20
                })
            }
            return result;
        },
        _addOrEditPop: function (type, onClickConfirm, info) {
            var self = this;
            var o = this.options;
            var pane = {
                type: "dec.client.widget.add.edit.popup",
                info: info,
                cardType: o.cardType,
                onClickConfirm: onClickConfirm,
                listeners: [
                    {
                        eventName: "EVENT_CLOSE",
                        action: function () {
                            BI.Popovers.remove(self.getName() + type);
                        }
                    }
                ]
            };
            BI.Popovers.create(self.getName() + type, {
                type: "bi.popover",
                header: type === EDIT ? BI.i18nText("Plugin-Dec-Management_Client_Pop_Title_Edit") : BI.i18nText("Plugin-Dec-Management_Client_Pop_Title_add"),
                body: pane,
                width: o.cardWidth,
                height: o.cardHeight,
                listeners: [
                    {
                        eventName: "EVENT_CLOSE",
                        action: function () {
                            BI.Popovers.remove(self.getName() + type);
                        }
                    }
                ]
            }).open(self.getName() + type);
        },
        formatItems: function (items) {
            var self = this;
            var o = this.options;
            var cloneItems = BI.deepClone(items);
            cloneItems = o.customFormat(cloneItems);
            if (o.showTools) {
                return BI.map(cloneItems, function (index, item) {
                    var oldItem = BI.find(items, function (index, o) {
                        return o.id === item.id;
                    });
                    return BI.extend(item, {
                        tableTools: {
                            type: "dec.client.table.tools",
                            limited: oldItem.editable != 0,
                            enable: oldItem.enable === 1,
                            enableDelete: oldItem.editable != 0,//不等于0 就是可以删除的
                            onDelete: function () {
                                self.store.deleteItems([oldItem.id])
                            },
                            onDisable: function (v) {
                                self.store.updateItem({id: oldItem.id, enable: v ? 1 : 0}, function (success) {
                                    if (!success) {
                                        BI.Msg.toast(BI.i18nText("Plugin-Dec-Management_Client_Set_Fail"), {level: "error"});
                                    }
                                })
                                //self.store.disableUser(v, self.getValue());
                            },
                            editHandler: function () {
                                self._addOrEditPop(EDIT, function (val, callback) {
                                    self.store.updateItem(val, callback)
                                }, oldItem)
                            }
                        }
                    })

                })
            }
            return items;
        },
        _calculateUserListHeight: function () {
            //  容器高度-工具栏-(表头+页码)
            return this.element.height() - 40 - 82;
        },
        reload: function () {
            this.store.initData();
        }

    });
    BI.shortcut("dec.client.widget.table", widget);
})();