!(function () {
    var Model = BI.inherit(Fix.Model, {
        _init: function () {
            this.perPage = this.options.perPage;

        },

        state: function () {
            return {
                items: [],
                page: 1,
                count: 0,
                perPage:1000,
                keyWord: "",
            };
        },

        childContext: [],

        context: [],

        computed: {},

        watch: {
            /*            count: function () {
                            var allPageCount = Math.ceil(this.model.count / this.perPage);
                            if (allPageCount <= 0) {
                                allPageCount = 1;
                            }
                            if (allPageCount < this.model.page) {
                                this.setPage(allPageCount);
                            }
                        },*/
            page: function () {
                this.initData();
            }
        },
        actions: {
            initData: function (callback) {

                var self = this, createFn = this.options.itemsCreateFn;
                var result = createFn(this.model.page, this.model.perPage, this.model.keyWord);
                if (result.success) {
                    this.model.count = result.data.total;
                    this.model.items = result.data.items;
                    BI.isFunction(callback) && callback();
                }

            },
            deleteItems: function (deleteIds) {
                var self = this;
                var deleteItemFn = this.options.deleteItemFn;
                var result = deleteItemFn(deleteIds);
                if (result.success) {
                    var currentSize = self.model.items.length;
                    var deleteSize = deleteIds.length;
                    if (currentSize == deleteSize && self.model.page > 1) {//当前页全部删除了而且当前页大于1直接page-1
                        self.setPage(self.model.page - 1)
                    } else {
                        self.initData();
                    }

                } else {
                    BI.Msg.toast(BI.i18nText("Plugin-Dec-Management_Client_Delete_Failed"), {level: "error"});
                }
            },
            apiTransferGroup: function (apiIds, groupId,callback) {
                var self = this;
                var transferAPIFn = this.options.transferAPIFn;
                var result = transferAPIFn(apiIds, groupId);
                if (result.success) {
                    var currentSize = self.model.items.length;
                    var deleteSize = apiIds.length;
                    if (currentSize == deleteSize && self.model.page > 1) {//当前页全部删除了而且当前页大于1直接page-1
                        self.setPage(self.model.page - 1)
                    } else {
                        self.initData();
                    }
                    callback(true);
                } else {
                    callback(false, result.errorMsg);
                }

            },
            updateItem: function (val, callback) {
                var self = this;
                var updateItemFn = this.options.updateItemFn;
                var splitIndex = -1
                var findItem = BI.find(self.model.items, function (index, item) {
                    splitIndex = index;
                    return item.id === val.id;
                });
                var upItem = BI.extend(BI.deepClone(findItem), val);
                var result = updateItemFn(upItem);
                if (!result.success) {
                    callback(false, result.errorMsg);
                    return;
                }
                self.model.items.splice(splitIndex, 1, result.data);
                callback(true);

            },
            addItem: function (item, callback) {
                var self = this;
                var addItemFn = this.options.addItemFn;
                var result = addItemFn(item);
                if (!result.success) {
                    callback(false, result.errorMsg);
                    return;
                }
                /*                var currentSize = self.model.items.length;
                                if (currentSize < self.perPage) {//当前不满足一页数据，需要插入
                                    self.model.items.push(result);
                                }
                                self.model.count = self.model.count + 1;*/
                //这边不能直接插入，涉及到一个排序问题只能是重新获取
                this.initData();
                callback(true);
            },
            setPage: function (v) {
                this.model.page = v;
            },
            setCount: function (v) {
                this.model.count = v;
            },
            updateUserListHeight: function (height) {
                //  每一行的实际占用高度为36
                // DEC-10669  用户管理列表，窗口自适应功能存在用户count参数为-1的可能  不能给他搞成负数
                // 又想了想,应该除了测试没有客户会把窗口缩小成一坨了.极限状态下每页取0个也不好.那就定两个吧
                // default改成8了 有的主题下初次显示可能有问题 JEE
                this.model.perPage = BI.max([8, Math.floor(height / 36)]);
            },
        }

    });
    BI.model("dec.model.client.widget.table", Model);
})();
