!(function () {
    var Tools = BI.inherit(BI.Widget, {

        props: {
            baseCls: "dec-user-row-tools",
            enable: true,
            info: {},
            enableEdit: true, // 是否允许编辑,
            limited: true, // 是否受限,即disable删除和禁用
            enableDelete: true, // 是否能被删除
            editHandler: BI.emptyFn
        },

        render: function () {
            var self = this, o = this.options;

            var editIcon = {
                type: "bi.icon_button",
                $value: "edit-user",
                invisible: !o.enableEdit, //  同步数据集开启,且不允许编辑用户信息的情况下才不显示
                cls: "normal-edit-font dec-user-row-tools-button",
                title: BI.i18nText("Dec-Basic_Edit"),
                stopPropagation: true,
                handler: function () {
                    o.editHandler()
                },
            };

            var disableIcon = {
                type: "dec.bubble.combo",
                disabled: !o.limited,
                el: {
                    type: "bi.icon_change_button",
                    $testId: "dec-icon-button",
                    $value: o.enable ? "disable-user" : "enable-user",
                    iconCls: "dec-user-row-tools-button " + (o.enable ? "disable-user-font" : "enable-user-font"),
                    ref: function (_ref) {
                        self.iconChangeButton = _ref;
                    },
                    title: function () {
                        return o.enable ? BI.i18nText("Plugin-Dec-Management_Client_Disable") : BI.i18nText("Plugin-Dec-Management_Client_Enable");
                    },
                    selected: !!o.enable,
                },
                text: function () {
                    return o.enable ? BI.i18nText("Plugin-Dec-Management_Client_Disable_confirm") + "?" : BI.i18nText("Plugin-Dec-Management_Client_Enable_confirm") + "?";
                },
                onClickConfirm: function () {
                    o.enable = !o.enable;
                    self.iconChangeButton.setIcon(o.enable ? "disable-user-font" : "enable-user-font");
                    o.onDisable(o.enable);
                    this.hideView();
                },
            };

            var deleteCombo = {
                type: "dec.bubble.combo",
                disabled: !o.enableDelete,
                el: {
                    type: "bi.icon_button",
                    $value: "delete-user",
                    cls: "delete-user-font dec-user-row-tools-button",
                    title: BI.i18nText("Dec-Basic_Delete"),
                },
                text: BI.i18nText("Plugin-Dec-Management_Client_Delete_confirm") + "?",
                onClickConfirm: function () {
                    this.hideView();
                    o.onDelete();
                },
            };

            return {
                type: "bi.center_adapt",
                scrollable: false,
                hgap: 10,
                items: [editIcon, disableIcon, deleteCombo],
            };
        },
    });

    Tools.EVENT_DELETE = "EVENT_DELETE";
    BI.shortcut("dec.client.table.tools", Tools);
}());
