/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2020-07-27
 **/
!(function () {
    /*定义个引入JS的前端方法*/
    var JsManagers = [];
    $.extend(Dec.Utils, {
        createJsManager: function (pluginId, root) {
            if (JsManagers[pluginId]) {
                return JsManagers[pluginId];
            }
            var manager = {
                id: pluginId,
                root: root,
                js: [],
                $base: $('script[src*="pluginId=' + pluginId + '"]'),
                importJs: function (path) {
                    var self = this;
                    var importSingle = function (item) {
                        if (self.js[item]) {
                            return;
                        }
                        self.js[item] = true;
                        var $js = $("<script/>").attr("type", "text/javascript")
                            .attr("src", Dec.fineServletURL + "/file?path=" + self.root + item + "&type=plain&parser=dynamic&pluginId=" + self.id + "&_t=" + new Date().getTime());
                        self.$base.before($js);
                    };
                    BI.$.each(path, function (i, item) {
                        importSingle(item);
                    });
                }
            };
            JsManagers[pluginId] = manager;
            return manager;
        }
    });
    var JsManager = Dec.Utils.createJsManager("com.tptj.plugin.hg.client.center.v10"
        , "com/tptj/plugin/hg/client/center/web/js/");

    JsManager.importJs([
        "client/client.constant.js", "client/client.model.js", "client/client.js",
        "client/client.request.js"]);//静态类与一些方法的js

    JsManager.importJs(["client/client/client.all.js", "client/client/client.info.js"]);//ezreal:客户端的js
    JsManager.importJs(["client/auth/auth.info.js","client/auth/auth.info.model.js", "client/auth/auth.all.js"]);//ezreal:认证类型

    JsManager.importJs(["client/group/api.group.item.js", "client/group/api.group.js", "client/group/api.group.model.js", "client/group/api.group.info.js"]);//ezreal:apiGroup的js
    JsManager.importJs(["client/api/api.all.js", "client/api/api.info.js","client/api/api.info.model.js", "client/api/api.transfer.info.js"]);//ezreal:api的js
    JsManager.importJs(["client/privilege/client.privilege.js", "client/privilege/client.privilege.model.js", "client/privilege/tree/tree.js", "client/privilege/tree/tree.model.js", "client/privilege/tree/item.js", "client/privilege/tree/node.js"]);//ezreal:权限的js
    JsManager.importJs(["client/privilege/carrier/privilege.carrier.selector.js", "client/privilege/carrier/privilege.carrier.selector.model.js"]);//ezreal:权限的js
    JsManager.importJs(["client/privilege/carrier/api/carrier.api.js", "client/privilege/carrier/api/carrier.api.model.js"]);//ezreal:权限的js
    JsManager.importJs(["client/privilege/carrier/client/carrier.client.js", "client/privilege/carrier/client/carrier.client.model.js", "client/privilege/carrier/client/client.item.js"]);//ezreal:权限的js

    JsManager.importJs(["client/privilege/privilege/privilege.js", "client/privilege/privilege/privilege.model.js"]);//ezreal:权限的js

    JsManager.importJs(["client/privilege/privilege/api/api.privilege.js", "client/privilege/privilege/api/api.privilege.model.js"]);//ezreal:权限的js

    JsManager.importJs(["client/privilege/privilege/client/client.privilege.js", "client/privilege/privilege/client/client.privilege.model.js"]);//ezreal:权限的js

    JsManager.importJs(["client/widget/client.table.js", "client/widget/client.table.model.js", "client/widget/client.add.edit.popup.js"
        , "client/widget/client.table.tools.js"
        , "client/widget/client.config.parameter.item.js"
        , "client/widget/client.config.parameter.list.js"
        , "client/widget/base/base.row.js"
        , "client/widget/base/base.check.table.js"
        , "client/widget/base/base.header.js"]);//通用的组件
    JsManager.importJs(["client/watcher/watcher.js",
        "client/watcher/watcher.model.js",
        "client/watcher/lineChart.js",
        "client/watcher/lineChart.model.js",
        "client/watcher/table.js",
        "client/watcher/table.model.js"
    ]);//jee:监控面板的js
    BI.$import(Dec.fineServletURL + "/file?path=com/tptj/plugin/hg/client/center/web/js/lib/echarts.common.js");

    BI.config("dec.constant.management.navigation", function (items) {
        items.push({
            value: "client-management",
            id: "decision-management-client",
            text: BI.i18nText("Plugin-Dec-Management_Client"),
            cardType: "dec.client.manage",
            cls: "management-directory-font"
        });
        return items;
    });
    //ezreal:协助开发的,后续删
    BI.Plugin.config(function (type, options) {

    }, function (type, object) {
        object.element.attr("shortcut", object.options.type);
    });
})();